import { Test } from "../test";
import { TestSubject } from "../subject";
import { TestSuiteResults } from "../suite";
import { TestExecutionSettings } from "../core";
import { LifecycleContainer } from "../util";
import { TestReportingSettings } from "../core/test-reporting-settings";
export declare class TestSuite implements LifecycleContainer {
    private _executionSettings?;
    private _reportingSettings?;
    constructor(_executionSettings?: TestExecutionSettings, _reportingSettings?: TestReportingSettings);
    static get current(): TestSuite;
    private static _global;
    static get global(): TestSuite;
    addEventListener(eventName: string, handler: Function): void;
    fireEvent(eventName: string): Promise<void>;
    private _lifecycleEvents;
    private _subjects;
    get subjects(): TestSubject[];
    get executionSettings(): TestExecutionSettings;
    get reportingSettings(): TestReportingSettings;
    get reporters(): import("..").Reporter[];
    set reportingSettings(value: TestReportingSettings);
    set executionSettings(value: TestExecutionSettings);
    get only(): boolean;
    get tests(): Test[];
    run(): Promise<TestSuiteResults>;
    addSubject(subject: TestSubject): void;
    private _fullyLoaded;
    private _hasFullyLoaded;
    private _outstandingLoads;
    private _isFullyLoaded;
    _startLoading(): () => void;
    get loaded(): Promise<void>;
}
