"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TestSuite = void 0;
var suite_1 = require("../suite");
var core_1 = require("../core");
var test_reporting_settings_1 = require("../core/test-reporting-settings");
var TestSuite = /** @class */ (function () {
    function TestSuite(_executionSettings, _reportingSettings) {
        var _this = this;
        this._executionSettings = _executionSettings;
        this._reportingSettings = _reportingSettings;
        this._lifecycleEvents = {};
        this._subjects = [];
        this._outstandingLoads = 0;
        this._isFullyLoaded = false;
        this._fullyLoaded = new Promise(function (resolve) { return _this._hasFullyLoaded = resolve; });
        this._fullyLoaded.then(function () { return _this.reporters.forEach(function (r) { return r.onSuiteLoaded ? r.onSuiteLoaded(_this) : null; }); });
        if (!this._executionSettings)
            this._executionSettings = new core_1.TestExecutionSettings();
        if (!this._reportingSettings)
            this._reportingSettings = new test_reporting_settings_1.TestReportingSettings();
    }
    Object.defineProperty(TestSuite, "current", {
        get: function () {
            return this.global || Zone.current.get('razminTestSuite');
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TestSuite, "global", {
        get: function () {
            if (!this._global) {
                var settings = (0, core_1.globalSuiteSettings)();
                if (settings) {
                    this._global = (0, core_1.setGlobalSuite)(new TestSuite(new core_1.TestExecutionSettings(settings.execution), new test_reporting_settings_1.TestReportingSettings(settings.reporting)));
                }
            }
            return this._global;
        },
        enumerable: false,
        configurable: true
    });
    TestSuite.prototype.addEventListener = function (eventName, handler) {
        if (!this._lifecycleEvents[eventName])
            this._lifecycleEvents[eventName] = [];
        this._lifecycleEvents[eventName].push(handler);
    };
    TestSuite.prototype.fireEvent = function (eventName) {
        return __awaiter(this, void 0, void 0, function () {
            var handlers, _i, handlers_1, handler;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        handlers = this._lifecycleEvents[eventName] || [];
                        _i = 0, handlers_1 = handlers;
                        _a.label = 1;
                    case 1:
                        if (!(_i < handlers_1.length)) return [3 /*break*/, 4];
                        handler = handlers_1[_i];
                        return [4 /*yield*/, handler()];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        _i++;
                        return [3 /*break*/, 1];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    Object.defineProperty(TestSuite.prototype, "subjects", {
        get: function () {
            return this._subjects.slice();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TestSuite.prototype, "executionSettings", {
        get: function () {
            return this._executionSettings;
        },
        set: function (value) {
            this._executionSettings = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TestSuite.prototype, "reportingSettings", {
        get: function () {
            return this._reportingSettings;
        },
        set: function (value) {
            this._reportingSettings = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TestSuite.prototype, "reporters", {
        get: function () {
            return this._reportingSettings.reporters || [];
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TestSuite.prototype, "only", {
        get: function () {
            return this.tests.some(function (x) { return x.options.only; });
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TestSuite.prototype, "tests", {
        get: function () {
            return [].concat.apply([], this.subjects.map(function (x) { return x.tests; }).filter(function (x) { return x; }));
        },
        enumerable: false,
        configurable: true
    });
    TestSuite.prototype.run = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _i, _a, reporter, results, _b, _c, subject, result, suiteResults, _d, _e, reporter;
            return __generator(this, function (_f) {
                switch (_f.label) {
                    case 0:
                        for (_i = 0, _a = this.reporters; _i < _a.length; _i++) {
                            reporter = _a[_i];
                            if (reporter.onSuiteStarted)
                                reporter.onSuiteStarted(this);
                        }
                        this.executionSettings.only = this.only;
                        results = [];
                        _b = 0, _c = this._subjects;
                        _f.label = 1;
                    case 1:
                        if (!(_b < _c.length)) return [3 /*break*/, 4];
                        subject = _c[_b];
                        return [4 /*yield*/, subject.run(this.reporters, this.executionSettings)];
                    case 2:
                        result = _f.sent();
                        results.push(result);
                        _f.label = 3;
                    case 3:
                        _b++;
                        return [3 /*break*/, 1];
                    case 4:
                        suiteResults = new suite_1.TestSuiteResults(this, results);
                        for (_d = 0, _e = this.reporters; _d < _e.length; _d++) {
                            reporter = _e[_d];
                            if (reporter.onSuiteFinished)
                                reporter.onSuiteFinished(this, suiteResults);
                        }
                        if (this._reportingSettings.exitAndReport !== false) {
                            if (typeof process !== 'undefined' && process.exit) {
                                process.exit(suiteResults.passed ? 0 : 1);
                            }
                            else {
                                console.log("Razmin: Testing finished. Passed=".concat(suiteResults.passed));
                            }
                        }
                        return [2 /*return*/, suiteResults];
                }
            });
        });
    };
    TestSuite.prototype.addSubject = function (subject) {
        this._subjects.push(subject);
    };
    TestSuite.prototype._startLoading = function () {
        var _this = this;
        this._outstandingLoads += 1;
        return function () {
            _this._outstandingLoads -= 1;
            if (_this._outstandingLoads === 0) {
                if (_this._isFullyLoaded) {
                    console.warn("[Razmin] Bug: Already signalled load finish");
                }
                else {
                    setTimeout(function () {
                        if (_this._outstandingLoads > 0)
                            return;
                        _this._isFullyLoaded = true;
                        _this._hasFullyLoaded();
                        _this.fireEvent('loaded');
                    });
                }
            }
        };
    };
    Object.defineProperty(TestSuite.prototype, "loaded", {
        get: function () {
            return this._fullyLoaded;
        },
        enumerable: false,
        configurable: true
    });
    return TestSuite;
}());
exports.TestSuite = TestSuite;
//# sourceMappingURL=test-suite.js.map