import "zone.js";
import { TestResult } from "./test-result";
import { TestFunction, TestOptions } from "./test-function";
import { TestExecutionSettings } from "../core";
export declare class Skip {
}
export declare class Timeout {
}
/**
 * Represents a unit test which can run itself.
 */
export declare class Test {
    private _description;
    private _function;
    private _options;
    constructor(_description: string, _function: TestFunction, _options?: TestOptions);
    get description(): string;
    get function(): TestFunction;
    get options(): TestOptions;
    /**
     * Execute the test within a Zone.js "sandbox".
     * @param executionSettings
     */
    private executeInSandbox;
    /**
     * Run the test to produce a result, based on whether the test throws an exception
     * or not.
     *
     * @param executionSettings
     */
    run(executionSettings?: TestExecutionSettings, contextName?: string): Promise<TestResult>;
}
