"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Test = exports.Timeout = exports.Skip = void 0;
require("zone.js");
var colors = require("colors/safe");
var test_result_1 = require("./test-result");
var util_1 = require("../util");
var core_1 = require("../core");
var Skip = /** @class */ (function () {
    function Skip() {
    }
    return Skip;
}());
exports.Skip = Skip;
var Timeout = /** @class */ (function () {
    function Timeout() {
    }
    return Timeout;
}());
exports.Timeout = Timeout;
/**
 * Represents a unit test which can run itself.
 */
var Test = /** @class */ (function () {
    function Test(_description, _function, _options) {
        if (_options === void 0) { _options = {}; }
        this._description = _description;
        this._function = _function;
        this._options = _options;
    }
    Object.defineProperty(Test.prototype, "description", {
        get: function () {
            return this._description;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Test.prototype, "function", {
        get: function () {
            return this._function;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Test.prototype, "options", {
        get: function () {
            return this._options || {};
        },
        enumerable: false,
        configurable: true
    });
    /**
     * Execute the test within a Zone.js "sandbox".
     * @param executionSettings
     */
    Test.prototype.executeInSandbox = function (executionSettings) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            var zone = new util_1.TestZone("Test Zone: ".concat(executionSettings.contextName), {
                razminTest: _this
            });
            var executionCompleted = false;
            var isStable = false;
            var isResolved = false;
            var isSuccessful = undefined;
            var timeoutHandle;
            var finalizerTimeout;
            var errorBeingFinalized;
            var finalizer = function (error) {
                if (errorBeingFinalized)
                    return;
                clearTimeout(finalizerTimeout);
                errorBeingFinalized = error;
                finalizerTimeout = setTimeout(function () {
                    if (isResolved)
                        return;
                    isSuccessful = !error;
                    isResolved = true;
                    if (error)
                        reject(error);
                    else
                        resolve();
                });
            };
            if (executionSettings.timeout) {
                timeoutHandle = setTimeout(function () { return finalizer(new Timeout()); }, executionSettings.timeout);
                var originalFinalizer_1 = finalizer;
                finalizer = function (error) {
                    clearTimeout(timeoutHandle);
                    originalFinalizer_1(error);
                };
            }
            zone.onError.subscribe(function (e) {
                if (isResolved) {
                    if (isSuccessful) {
                        console.error("Caught error after test completed successfully (this is a bug):");
                        console.error(e);
                        throw new Error("Caught error after test completed successfully (this is a bug)");
                    }
                    else {
                        console.error("(*) Caught additional error after test '".concat(_this.description, "' had already failed:"));
                        console.error(e);
                    }
                }
                finalizer(e);
            });
            zone.onStable.subscribe(function (e) {
                isStable = true;
                if (executionCompleted && !isResolved)
                    finalizer();
            });
            if (executionSettings.verbose)
                console.log("Running test: ".concat(executionSettings.contextName));
            zone.invoke(function () { return __awaiter(_this, void 0, void 0, function () {
                var uncaughtExceptionHandler, takesDone, e_1;
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            uncaughtExceptionHandler = function (err) {
                                if (Zone.current !== zone.zone) {
                                    console.warn("Skipping unrelated uncaught exception from a different zone");
                                    return;
                                }
                                console.log("UNCAUGHT EXCEPTION:");
                                console.error(err);
                            };
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 6, , 7]);
                            takesDone = this.function.length > 0;
                            if (!takesDone) return [3 /*break*/, 3];
                            return [4 /*yield*/, new Promise(function (res, rej) { return __awaiter(_this, void 0, void 0, function () {
                                    var done, e_2;
                                    return __generator(this, function (_a) {
                                        switch (_a.label) {
                                            case 0:
                                                done = Object.assign(function () { return res(); }, { fail: function () { return rej(); } });
                                                _a.label = 1;
                                            case 1:
                                                _a.trys.push([1, 3, , 4]);
                                                return [4 /*yield*/, this.function(done)];
                                            case 2:
                                                _a.sent();
                                                return [3 /*break*/, 4];
                                            case 3:
                                                e_2 = _a.sent();
                                                rej(e_2);
                                                return [3 /*break*/, 4];
                                            case 4: return [2 /*return*/];
                                        }
                                    });
                                }); })];
                        case 2:
                            _a.sent();
                            return [3 /*break*/, 5];
                        case 3: return [4 /*yield*/, this.function(undefined)];
                        case 4:
                            _a.sent();
                            _a.label = 5;
                        case 5:
                            executionCompleted = true;
                            if (isStable && !isResolved) {
                                finalizer();
                            }
                            return [3 /*break*/, 7];
                        case 6:
                            e_1 = _a.sent();
                            if (isResolved) {
                                if (isSuccessful) {
                                    console.error("Caught error after test successfully completed (this is a bug):");
                                    console.error(e_1);
                                    throw new Error("Caught error after test successfully completed (this is a bug)");
                                }
                                else {
                                    console.error("(*) Caught additional error after test '".concat(this.description, "' had already failed:"));
                                    console.error(e_1);
                                }
                            }
                            finalizer(e_1);
                            return [3 /*break*/, 7];
                        case 7: return [2 /*return*/];
                    }
                });
            }); });
        });
    };
    /**
     * Run the test to produce a result, based on whether the test throws an exception
     * or not.
     *
     * @param executionSettings
     */
    Test.prototype.run = function (executionSettings, contextName) {
        return __awaiter(this, void 0, void 0, function () {
            var startedAt, finishedAt, duration, result, e_3, indent, message, stackLine, deepStackLines, stack, parts, showStack;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this.options.skip)
                            return [2 /*return*/, new test_result_1.TestResult({ description: this._description, passed: 'skip', message: "Skipped" })];
                        executionSettings = (executionSettings || new core_1.TestExecutionSettings()).clone({ contextName: contextName });
                        startedAt = Date.now();
                        finishedAt = undefined;
                        duration = undefined;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 6, , 7]);
                        result = void 0;
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, , 4, 5]);
                        return [4 /*yield*/, this.executeInSandbox(executionSettings)];
                    case 3:
                        result = _a.sent();
                        return [3 /*break*/, 5];
                    case 4:
                        finishedAt = Date.now();
                        duration = finishedAt - startedAt;
                        return [7 /*endfinally*/];
                    case 5: 
                    // Execution has completed successfully.
                    return [2 /*return*/, new test_result_1.TestResult({
                            description: this._description,
                            passed: true,
                            message: "Success",
                            duration: duration
                        })];
                    case 6:
                        e_3 = _a.sent();
                        // An exception was caught while handling the test.
                        // Produce a result which indicates the error.
                        // If the test was skipped, return a skip result 
                        if (e_3 instanceof Skip)
                            return [2 /*return*/, new test_result_1.TestResult({ description: this._description, passed: 'skip', message: 'Skipped' })];
                        // If it timed out, report that
                        if (e_3 instanceof Timeout) {
                            return [2 /*return*/, new test_result_1.TestResult({
                                    description: this._description,
                                    passed: false,
                                    message: "Timed out (".concat(executionSettings.timeout, "ms) without completing.") + ((this.function.length > 0 ? ("\n"
                                        + "This test accepts a done() parameter. Did you forget to call it?\n"
                                        + "Note: You only need to use done() when using libraries/APIs that\n"
                                        + "are not Zone-patched (or not patched properly).\n"
                                        + "** If you are not using it, you should remove it to prevent the\n"
                                        + "test from hanging.") : "")),
                                    duration: duration
                                })];
                        }
                        indent = '     ';
                        message = e_3.message ? e_3.message : e_3 + "";
                        stackLine = null;
                        deepStackLines = [];
                        if (e_3.stack) {
                            stack = e_3.stack + "";
                            parts = (stack || '').split(/\n/g);
                            stackLine = (parts[1] || '').replace(/^ *at /, '');
                            deepStackLines =
                                ("           ".concat(stack))
                                    .replace(/^[^\n]*\n/, '') // remove first line
                                    .replace(/^ *at ?/gm, '') // remove "at"
                                    .replace(/\n/g, "\n          ") // indent all lines
                                    .split(/\n/g)
                                    .slice(1);
                        }
                        showStack = true;
                        if (e_3.constructor.name == "AssertionError")
                            showStack = false;
                        return [2 /*return*/, new test_result_1.TestResult({
                                description: this._description,
                                passed: false,
                                message: "".concat(indent).concat(colors.red('×'), " ").concat(message, "\n")
                                    + (stackLine ?
                                        "       ".concat(colors.gray('at'), " ").concat(colors.white(stackLine))
                                        : '')
                                    + (showStack ?
                                        "\n".concat(colors.gray(deepStackLines.join("\n")))
                                        : ''),
                                duration: duration
                            })];
                    case 7: return [2 /*return*/];
                }
            });
        });
    };
    return Test;
}());
exports.Test = Test;
//# sourceMappingURL=test.js.map